/* filelines.c : fonctions de lecture de lignes et fichiers */
#include <stdio.h>
#include <stdlib.h>
/* Fonction de lecture d'une ligne avec allocation dynamique */

int readline(FILE *fp,char **res)
{int taille_cour,curseur;
 char *tampon,c;
 
 curseur=0;
 taille_cour=16;
 
 /* Allocation initiale de taille_cour cases pour le tampon */
 tampon=(char *)malloc(sizeof(char)*taille_cour);
 
 while ((c=getc(fp))!=EOF && c!='\n')
   {tampon[curseur++]=c;
   if (curseur==taille_cour) 
     {taille_cour*=2; /* doubler le tampon: Ne Pas Oublier Sizeof! */
     realloc(tampon,taille_cour*sizeof(char)); };
   };
 tampon[curseur]='\0';
 *res=tampon;
 if (c==EOF) {return 0;};
 return 1;
}
 
/* Fonction de lecture d'un fichier avec allocation dynamique */
 
int readfile(FILE *pf, char ***lignes, int *nlines)
{char *buf,**tmp;
 int taille_cour=100,i=0;
 
 /* commencons la lecture apres avoir alloue la memoire */
 tmp=(char **)malloc(taille_cour*sizeof(char *));
 
 while (readline(pf,&buf)!=0)
   { tmp[i++]=buf;
   if (i==taille_cour) /* il faut doubler le tampon */
     {taille_cour*=2;
     realloc(tmp,taille_cour*sizeof(char *));
     };
   };
 tmp[i]=buf;
 (*lignes)=tmp;
 (*nlines)=i;
 return(0);
}
